<template>
  <div>
    <b-field
      :type="{ 'is-danger': $v.email.$error }"
      :message="{
        'Email is required': $v.email.$error && !$v.email.required,
        'Email is not in correct format': $v.email.$error && !$v.email.email
      }"
      label="Email"
    >
      <b-input
        v-model="$v.email.$model"
        size="is-medium"
      />
    </b-field>

    <b-field
      :type="{ 'is-danger': $v.password.$error }"
      :message="{
        'Password is required': $v.password.$error && !$v.password.required,
        'Password should have at least 8 characters': $v.password.$error && !$v.password.minLength
      }"
      label="Password"
    >
      <b-input
        v-model="$v.password.$model"
        type="password"
        size="is-medium"
        password-reveal
      />
    </b-field>

    <b-field>
      <b-button
        @click="doLogin"
        :expanded="true"
        :loading="processingLogin"
        :disabled="processingLogin"
        type="is-primary"
        size="is-medium"
      >
        Login
      </b-button>
    </b-field>
  </div>
</template>

<script>
import { required, email, minLength } from 'vuelidate/lib/validators'

export default {
  name: 'LoginForm',

  props: {
    onValid: {
      type: Function,
      required: true
    },
    processingLogin: {
      type: Boolean,
      required: true
    }
  },

  data () {
    return {
      email: '',
      password: ''
    }
  },

  validations: {
    email: { required, email },
    password: { required, minLength: minLength(8) }
  },

  methods: {
    doLogin () {
      this.$v.$touch()
      if (!this.$v.$invalid) {
        this.onValid({
          'email': this.email,
          'password': this.password
        })
      }
    }
  }

}
</script>
